/*****************************************************************************
 *                                                                           *
 * File:                                                                     *
 *  chtoetool.h                                                              *
 *                                                                           *
 * Description:                                                              *
 *  chtoetool definitions.                                                   *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License, version 2, as       *
 * published by the Free Software Foundation.                                *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED    *
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF      *
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.                     *
 *                                                                           *
 * http://www.chelsio.com                                                    *
 *                                                                           *
 * Copyright (c) 2003 - 2005 Chelsio Communications, Inc.                    *
 * All rights reserved.                                                      *
 *                                                                           *
 * Maintainers: maintainers@chelsio.com                                      *
 *                                                                           *
 * Authors: Dimitrios Michailidis   <dm@chelsio.com>                         *
 *                                                                           *
 * History:                                                                  *
 *                                                                           *
 ****************************************************************************/
/* $Date: 2005/11/17 03:31:26 $ $RCSfile: chtoetool.h,v $ $Revision: 1.12 $ */

#ifndef __CHTOETOOL_LINUX_H__
#define __CHTOETOOL_LINUX_H__

#ifndef TCB_SIZE
# define TCB_SIZE   128
#endif

/* TCB size in 32-bit words */
#define TCB_WORDS (TCB_SIZE / 4)
#define MAX_NMTUS	16

enum {
	TOETOOL_SETREG = 1024,
	TOETOOL_GETREG,
	TOETOOL_SETTPI,
	TOETOOL_GETTPI,
	TOETOOL_DEVUP,
	TOETOOL_GETMTUTAB,
	TOETOOL_SETMTUTAB,
	TOETOOL_GETMTU,
	TOETOOL_SET_PM,
	TOETOOL_GET_PM,
	TOETOOL_GET_TCAM,
	TOETOOL_SET_TCAM,
	TOETOOL_GET_TCB,
	TOETOOL_READ_TCAM_WORD,
	TOETOOL_T1POWERSAVE,
};

struct toetool_reg {
	uint32_t cmd;
	uint32_t addr;
	uint32_t val;
};

struct toetool_mtus {
	uint32_t cmd;
	uint32_t nmtus;
	uint16_t mtus[MAX_NMTUS];
};

struct toetool_pm {
	uint32_t cmd;
	uint32_t tx_pg_sz;
	uint32_t tx_num_pg;
	uint32_t rx_pg_sz;
	uint32_t rx_num_pg;
	uint32_t pm_total;
};

struct toetool_tcam {
	uint32_t cmd;
	uint32_t tcam_size;
	uint32_t nservers;
	uint32_t nroutes;
};

struct toetool_tcb {
	uint32_t cmd;
	uint32_t tcb_index;
	uint32_t tcb_data[TCB_WORDS];
};

struct toetool_tcam_word {
	uint32_t cmd;
	uint32_t addr;
	uint32_t buf[3];
};

struct toetool_t1powersave {
	uint32_t cmd;
	uint32_t mode;
};

#define SIOCTOETOOL SIOCDEVPRIVATE
#endif
