/* $Date: 2005/03/08 05:17:36 $ $RCSfile: cspi.c,v $ $Revision: 1.16 $ */
#include "common.h"
#include "regs.h"
#include "cspi.h"

FILE_IDENT("@(#) $Id: cspi.c,v 1.16 2005/03/08 05:17:36 sbardone Exp $");

struct pecspi {
	adapter_t *adapter;
};

int t1_cspi_intr_enable(struct pecspi *cspi)
{
	t1_write_reg_4(cspi->adapter, A_CSPI_INTR_ENABLE, 0xffffffff);
	return 0;
}

int t1_cspi_intr_disable(struct pecspi *cspi)
{
	t1_write_reg_4(cspi->adapter, A_CSPI_INTR_ENABLE, 0);
	return 0;
}

int t1_cspi_intr_status_read(struct pecspi *cspi, u32 *status)
{
	*status = t1_read_reg_4(cspi->adapter, A_CSPI_INTR_STATUS);

	/* TBD XXX Need to poll in case of parity/overflow */
	/* t1_write_reg_4( adapter, CSPI_REG_RAMSTATUS, ); */

	return 0;
}

int t1_cspi_init(struct pecspi *cspi)
{
	adapter_t *adapter = cspi->adapter;

	t1_write_reg_4(adapter, A_CSPI_CALENDAR_LEN, 15);
	t1_write_reg_4(adapter, A_CSPI_FIFO_STATUS_ENABLE, 1);
	return 0;
}

struct pecspi *t1_cspi_create(adapter_t *adapter)
{
	struct pecspi *cspi = t1_os_malloc_wait_zero(sizeof(*cspi));

	if (cspi)
		cspi->adapter = adapter;
	return cspi;
}

void t1_cspi_destroy(struct pecspi *cspi)
{
	t1_os_free((void *)cspi, sizeof(*cspi));
}
