/* $Date: 2005/03/08 05:17:36 $ $RCSfile: dummy_mac.c,v $ $Revision: 1.20 $ */
#include "gmac.h"

FILE_IDENT("@(#) $Id: dummy_mac.c,v 1.20 2005/03/08 05:17:36 sbardone Exp $");

struct _cmac_instance {
	int index;
};

static struct cmac_statistics dummy_stats;

static int dummy_mac_generic_op(struct cmac *mac)
{
	return 0;
}

static int dummy_mac_generic_op2(struct cmac *mac, int x)
{
	return 0;
}

static int mac_get_address(struct cmac *mac, u8 addr[6])
{
	u8 fake_addr[6] = { 0, 7, 0x43, 1, 0, 8 };

	memcpy(addr, fake_addr, 6);
	return 0;
}

static int mac_set_address(struct cmac *mac, u8 addr[6])
{
	return 0;
}

static const struct cmac_statistics *mac_update_statistics(struct cmac *mac,
							   int flag)
{
	return &dummy_stats;
}

static int dummy_mac_enable(struct cmac *mac, int which)
{
	cmac_instance *p = mac->instance;

	t1_os_link_changed(mac->adapter, p->index, 1, SPEED_1000, DUPLEX_FULL,
			   0);
	return 0;
}

static int dummy_mac_disable(struct cmac *mac, int which)
{
	return 0;
}

static int dummy_mac_get_speed_duplex_fc(struct cmac *mac, int *speed,
					 int *duplex, int *fc)
{
	if (speed) *speed = SPEED_1000;
	if (duplex) *duplex = DUPLEX_FULL;
	if (fc) *fc = 0;
	return 0;
}

static int dummy_mac_set_speed_duplex_fc(struct cmac *mac, int speed,
					 int duplex, int fc)
{
	return 0;
}

static int dummy_mac_set_rx_mode(struct cmac *mac, struct t1_rx_mode *rm)
{
	return 0;
}

static void dummy_mac_destroy(struct cmac *mac)
{
	t1_os_free((void *)mac, sizeof(cmac) + sizeof(cmac_instance));
}

static struct cmac_ops dummy_mac_ops = {
	.destroy                  = dummy_mac_destroy,
	.reset                    = dummy_mac_generic_op,
	.interrupt_enable         = dummy_mac_generic_op,
	.interrupt_disable        = dummy_mac_generic_op,
	.interrupt_clear          = dummy_mac_generic_op,
	.enable                   = dummy_mac_enable,
	.disable                  = dummy_mac_disable,
	.set_rx_mode              = dummy_mac_generic_op,
	.get_speed_duplex_fc      = dummy_mac_get_speed_duplex_fc,
	.set_speed_duplex_fc      = dummy_mac_set_speed_duplex_fc,
	.statistics_update        = mac_update_statistics,
	.macaddress_get           = mac_get_address,
	.macaddress_set           = mac_set_address,
};

static struct cmac *dummy_mac_create(adapter_t *adapter, int index)
{
	struct cmac *mac;

	mac = t1_os_malloc_wait_zero(sizeof(*mac) + sizeof(cmac_instance));
	if (!mac) return NULL;

	mac->ops = &dummy_mac_ops;
	mac->instance = (cmac_instance *)(mac + 1);

	mac->adapter = adapter;
	mac->instance->index = index;
	return mac;
}

struct gmac t1_dummy_mac_ops = {
	.stats_update_period = 0,
	.create              = dummy_mac_create
};
