/* $Date: 2005/03/08 05:17:36 $ $RCSfile: dummy_phy.c,v $ $Revision: 1.18 $ */
#include "cphy.h"

FILE_IDENT("@(#) $Id: dummy_phy.c,v 1.18 2005/03/08 05:17:36 sbardone Exp $");

static int dummy_phy_reset(struct cphy *cphy, int wait)
{
	return 0;
}

static int dummy_phy_interrupt_op(struct cphy *cphy)
{
	return 0;
}

static int dummy_phy_interrupt_handler(struct cphy *cphy)
{
	return 0;
}

static int dummy_phy_get_link_status(struct cphy *cphy, int *link_ok,
				     int *speed, int *duplex, int *fc)
{
	if (link_ok) *link_ok = 1;
	if (speed)   *speed = SPEED_1000;
	if (duplex)  *duplex = DUPLEX_FULL;
	if (fc)      *fc = 0;
	return 0;
}

static void dummy_phy_destroy(struct cphy *cphy)
{
        t1_os_free((void *)cphy, sizeof(*cphy));
}

static struct cphy_ops dummy_phy_ops = {
	.destroy               = dummy_phy_destroy,
	.reset                 = dummy_phy_reset,
	.interrupt_enable      = dummy_phy_interrupt_op,
	.interrupt_disable     = dummy_phy_interrupt_op,
	.interrupt_clear       = dummy_phy_interrupt_op,
	.interrupt_handler     = dummy_phy_interrupt_handler,
	.get_link_status       = dummy_phy_get_link_status,
};

static struct cphy *dummy_phy_create(adapter_t *adapter, int phy_addr,
				     struct mdio_ops *mdio_ops)
{
	struct cphy *phy = t1_os_malloc_wait_zero(sizeof(*phy));

	if (phy)
		cphy_init(phy, adapter, phy_addr, &dummy_phy_ops, mdio_ops);
	return phy;
}

struct gphy t1_dummy_phy_ops = {
	dummy_phy_create,
};
