def make_mask(mask_len):
	return (1 << mask_len) - 1

def declare_field(name, offset, len):
	print "#define S_%s    %u" % (name, offset)
	print "#define M_%s    0x%X" % (name, make_mask(len))
	if offset + len <= 32:
		print "#define V_%s(x) ((x) << S_%s)" % (name, name)
	else:
		print "#define V_%s(x) ((__u64)(x) << S_%s)" % (name, name)
	print "#define G_%s(x) (((x) >> S_%s) & M_%s)" % (name, name, name)
	print "#define C_%s(x) ((x) & ~((__typeof(x))M_%s << S_%s))\n" % (name, name, name)

def declare_bit(name, offset):
	print "#define S_%s %u" % (name, offset)
	if offset < 32:
		print "#define V_%s (1U << S_%s)" % (name, name)
	else:
                print "#define V_%s (1ULL << S_%s)" % (name, name)
	print

def process_field_list(l, offset_adj):
    for i in l:
        if len(i) == 2:
            declare_bit(i[0], i[1] + offset_adj)
        else:
            declare_field(i[0], i[1] + offset_adj, i[2])

def declare_tcb_field(name, first_bit, last_bit):
    word, offset = first_bit / 32, first_bit % 32
    len = last_bit - first_bit + 1

    print "#define W_TCB_%s %u" % (name, word)
    print "#define S_TCB_%s %u" % (name, offset)
    print "#define M_TCB_%s 0x%X\n" % (name, make_mask(len))

def header_prologue(guard):
    print "/*\n * This file is automatically generated --- any changes will be lost.\n */\n"
    print "#ifndef %s\n#define %s\n" % (guard, guard)

def header_epilogue(guard):
    print "#endif /* %s */" % guard

