from field_defs import *

# OPT0 low-half definitions
opt0l_fields = (
    ('ULP_MODE', 0, 3),
    ('RCV_BUFSIZ', 4, 14),
    ('TOS', 18, 6)
)

# OPT0 upper-half definitions
opt0h_fields = (
    ('DELACK', 24),
    ('NO_CONG', 25),
    ('SRC_MAC_SEL', 26, 2),
    ('L2T_IDX', 28, 8),
    ('TCAM_BYPASS', 40),
    ('NAGLE', 41),
    ('WND_SCALE', 42, 4),
    ('KEEP_ALIVE', 46),
    ('MAX_RETRANS', 47, 4),
    ('MAX_RETRANS_OVERRIDE', 51),
    ('MSS_IDX', 52, 3),
    ('MSS_IDX_OVERRIDE', 55)
)

# OPT1 low-half definitions
opt1_fields = (
    ('VLAN_TAG', 6, 12),
    ('PARTIAL_TERM', 18),
    ('CONN_POLICY', 19, 2),
    ('SYN_DEFENSE', 21)
)

# TOS and TID fields for passive establish and passive accept_req
pass_open_tos_tid_fields = (
    ('PASS_OPEN_TID', 0, 24),
    ('PASS_OPEN_TOS', 24, 8)
)

# Interface/VLAN tag field for active open requests
act_open_iff_fields = (
    ('ACT_OPEN_IFF_VLAN_TAG', 20, 12),
)

# TX_DATA flags
tx_data_flags_fields = (
    ('TX_ULP_SUBMODE', 6, 4),
    ('TX_ULP_MODE', 10, 4),
    ('TX_SHOVE', 14),
    ('TX_MORE', 15)
)

# L2T_WRITE_REQ/L2T_READ_RPL parameters
l2t_op_param_fields = (
    ('L2TOP_IDX', 0, 8),
    ('L2TOP_VLAN', 8, 12),
    ('L2TOP_IFF', 20, 4),
    ('L2TOP_STATUS', 24, 8)
)

# RTE_DELETE_REQ fields
rte_delete_req_fields = (
    ('RTE_DELETE_REQ_LUT_IX', 8, 22),
)

# RTE_WRITE_REQ fields
rte_write_req_fields = (
    ('RTE_WRITE_REQ_L2T_IX', 0, 8),
    ('RTE_WRITE_REQ_LUT_IX', 8, 22),
    ('RTE_WRITE_REQ_CTL', 30, 2)
)

# RTE_READ_REQ fields
rte_read_req_fields = (
    ('RTE_READ_REQ_LUT_IX', 8, 22),
    ('RTE_READ_REQ_SELECT', 31)
)

# RX_DATA_DDP fields
ddp_status_fields = (
    ('DDP_ULP_MODE', 0, 4),
    ('DDP_INVALID_PAGEPOD', 4, 1),
    ('DDP_INVALID_TID', 5, 1),
    ('DDP_INVALID_COLOR', 6, 1),
    ('DDP_INVALID_OFFSET', 7, 1),
    ('DDP_INVALID_ULIMIT', 8, 1),
    ('DDP_INVALID_TAG', 9, 1),
    ('DDP_INVALID_DCRC', 10, 1),
    ('DDP_INVALID_HCRC', 11, 1),
    ('DDP_INVALID_PADDING', 12, 1)
)

header_prologue('_CPL5_DEFS_H')
process_field_list(opt0l_fields, 8)
process_field_list(opt0h_fields, -24)
process_field_list(opt1_fields, 0)
process_field_list(pass_open_tos_tid_fields, 0)
process_field_list(act_open_iff_fields, 0)
process_field_list(tx_data_flags_fields, 0)
process_field_list(l2t_op_param_fields, 0)
process_field_list(rte_delete_req_fields, 0)
process_field_list(rte_write_req_fields, 0)
process_field_list(rte_read_req_fields, 0)
process_field_list(ddp_status_fields, 0)
header_epilogue('_CPL5_DEFS_H')

