/*
 * ulp.h
 */

#ifndef __CHTOE_ULP_H__
#define __CHTOE_ULP_H__

#include <linux/config.h>

#undef __ULP_DEBUG__

#ifdef CONFIG_CHELSIO_T1_ULP

#include <linux/kernel.h>
#include <linux/toedev.h>
#include <linux/pci.h>

/*
 * Getting to the DDP table in a toe device.
 */
#define ULPDATA(dev) ((dev)->ulp)

struct toedev;
struct sock;
struct sk_buff;

void *t1_init_ulp(struct toedev *dev);
void t1_free_ulp(struct toedev *dev);
__u16 ulp_adjust_tx_data(__u16 ulp_mode, int len);
void ulp_new_rx_data(struct sock *sk, struct sk_buff *skb);
void ulp_new_rx_data_ddp(struct sock *sk, struct sk_buff *skb);
void ulp_new_rx_iscsi_hdr(struct sock *sk, struct sk_buff *skb);

struct ulp_info {
    struct toedev 	*tdev;
    void 		*dmt;
    unsigned int	max_rx_pkt_size;
    unsigned int 	max_tx_pkt_size;
    __u8 		version;
};
#else

#define t1_init_ulp(toedev) NULL
#define t1_free_ulp(toedev)
#define ulp_adjust_tx_data(mode, len) (mode)
#define ulp_new_rx_data(sk, skb)
#define ulp_new_rx_data_ddp(sk, skb)
#define ulp_new_rx_iscsi_hdr(sk, skb)

#endif

#endif
