#ifndef __ULP_INTERFACE_H__
#define __ULP_INTERFACE_H__

#include<asm/scatterlist.h>

/* used in t1_ddp_map */
#define DDP_PAGE_SIZE_4K	0
#define DDP_PAGE_SIZE_8K	1
#define DDP_PAGE_SIZE_16K	2

/*
   use the 1st bit in cb as the the ready for read bit: so the
   user won't grab it before cpl_rx_data_ddp get a chance to save
   the pdu length, data crc and in it.
   user will need to check this bit before taking this sk_buff
   out of the receive_queue
*/

/* these bits are set by RX_DATA_DDP msg handler */
#define DDP_STATUS_DATA_DDPED   0x1
#define DDP_STATUS_HCRC_ERROR   0x2
#define DDP_STATUS_DCRC_ERROR   0x4
#define DDP_STATUS_PAD_ERROR    0x8

#define SKB_ULPINFO(skb)     ((skb)->cb)

/* the info. below is passed to application via sk_buff's cb[] */
struct skb_ulpinfo {
    __u8 data_ready;
    __u8 mode;		/* 1 -- ULP mode, 0 -- TOE mode */ 
    __u8 data_gap;
    __u8 ddp_status;
    __u32 pdu_length;
    __u32 data_digest;
};

struct ulpdev_data {
    unsigned int max_rx_pkt_size;
    unsigned int max_tx_pkt_size;
    unsigned int tid;		/* save for unmap, in case conn gone */
    unsigned char pad_included;	/* pad included or not */
    unsigned char tag_id_bits;	
    unsigned char tag_color_bits;
    void	*privdata;
};


extern int t1_tom_set_conn_rx_ulp_mode(struct sock *sk, unsigned char mode, 
	unsigned char hcrc, unsigned char dcrc, unsigned long pagesize);
extern int t1_tom_udev_data(struct sock *sk, struct ulpdev_data *dp);
extern int t1_tom_ddp_map(struct sock *sk, int sgcnt, struct scatterlist *sg,
        __u32 offset, __u32 *tag, __u8 psize, void *priv);
extern int t1_tom_ddp_unmap(struct sock *sk, __u32 tag, __u32 psize, struct ulpdev_data *udata);
extern int t1_tom_ddp_tag_nextalias(struct sock *sk, __u32 *ptag);

#endif
