#ifndef _KDEBUG_H
#define _KDEBUG_H 1

/*
 * This notifier is to replace hardcoded 
 * entries in the keyboard and serial driver
 * used by kdb
 */
#include <linux/notifier.h>

struct pt_regs;

struct kdebug_args { 
	struct pt_regs *regs;
	const char *str;
}; 

extern struct notifier_block *kdebug_chain;

static inline int notify_kdebug(char *str,struct pt_regs *regs)
{ 
	struct kdebug_args args = { .regs=regs, .str=str }; 
	return notifier_call_chain(&kdebug_chain, (unsigned long)0, &args); 
} 

#if defined(CONFIG_SERIAL_8250_CONSOLE) || defined(CONFIG_SGI_L1_SERIAL_CONSOLE)
extern struct kdebug_serial {
	int io_type;
	unsigned long iobase;
	unsigned long ioreg_shift;
} kdebug_serial;
#endif

#endif
